// Implementation for 'global.h'.
// Must be included in each project using that header,
// usually it's done at the bottom of 'my_thr_init.cc'.

t_write_log_ex *libgovernor_write_log_ex = NULL;
t_get_log_ex_properties *libgovernor_get_log_ex_properties = NULL;

unsigned govlog_enabled_tags = _L_MASK_ALWAYS_ENABLED;	// unmaskable tags should be enabled even if libgovernor.so misses logging functions
int govlog_unconditional_log_if = 0;	// if true, GOV_LOG_IF(cond, ...) works as if "cond" is true; used to debug logging itself; not using "bool" as problematic throughout MySQL/MariaDB/Governor compiling environments

#undef pthread_mutex_lock
#undef pthread_mutex_unlock
#undef pthread_mutex_trylock

static void do_nothing()
{
}

int (*govlve_mutex_lock)   (pthread_mutex_t *mutex) = pthread_mutex_lock;
int (*govlve_mutex_trylock)(pthread_mutex_t *mutex) = pthread_mutex_trylock;
int (*govlve_mutex_unlock) (pthread_mutex_t *mutex) = pthread_mutex_unlock;
void (*govlve_slot_reserve)() = do_nothing;
void (*govlve_slot_release)() = do_nothing;

// Prevent 'pthread_mutex_...' reuse, because we #undef'ed them above, and the surrounding code can rely on its own #define's.
// Anyways we must include this whole file at the bottom of some *.c, but just in case:
#define pthread_mutex_lock(m)		error: pthread_mutex_...() spoiled; include this file only at the bottom
#define pthread_mutex_trylock(m)	error: pthread_mutex_...() spoiled; include this file only at the bottom
#define pthread_mutex_unlock(m)		error: pthread_mutex_...() spoiled; include this file only at the bottom
